---
title: Solaris Build Prerequisites
slug: Mozilla/Developer_guide/Build_Instructions/Solaris_Prerequisites
tags:
  - Build documentation
  - Developing Mozilla
---
<h3 id="Required_Software">Required Software</h3>

<p><a class="external" href="http://www.opensolaris.org/">OpenSolaris</a> (and therefore also Solaris 11) can build Mozilla with a few extra packages installed:</p>

<ul>
 <li>OpenSolaris builds <strong>before</strong> <code>snv_133</code>:</li>
</ul>

<pre>$ pfexec pkg install SUNWhea SUNWmercurial SUNWaudh SUNWxwinc SUNWxorg-headers SUNWgm4 SUNWgnome-common-devel SUNWcvs SUNWgmake sunstudio rust
</pre>

<ul>
 <li>OpenSolaris builds <strong>since </strong><code>snv_133</code>:</li>
</ul>

<pre>$ pfexec pkg install x11/header mercurial header-audio x11/header header-xorg gnu-m4 gnome/gettext cvs gnu-make sunstudio rust

</pre>

<div>
<ul style="margin-top: 0px; margin-right: 0px; margin-bottom: 1.7em; margin-left: 25px; padding-top: 0px; padding-right: 0px; padding-bottom: 0px; padding-left: 0px;">
 <li><code>gcc</code> or <code>gcc-43</code> is required to build <code>js-ctypes</code></li>
 <li><a class="external" href="http://ftp.gnu.org/gnu/autoconf/autoconf-2.13.tar.gz">autoconf 2.13</a> is necessary if you get source code from hg repo. Download the source tarball, untar it, <code>./configure --program-suffix=-2.13; gmake; pfexec gmake install</code>. Autoconf 2.5x will <strong>not</strong> work. See {{ Bug(104642) }} for details. </li>
 <li>It should now be possible to build post-Quantum using only G++, see smartos pkgsrc/www/firefox[57-64]</li>
 <li>Now 64-bit only (unless someone contributes a rust machine description for <code>i686-sun-solaris</code>)</li>
</ul>

<h3 id="Build_Environment">Build Environment</h3>
</div>

<p>Get source code from hg repo or source tarball.</p>

<ul>
 <li>Sun Studio 12.1 is recommended for building Mozilla project (however there're some bugs you need workarounds).</li>
 <li>Sun Studio 12 or gcc-43 is usable but you need some patches.</li>
 <li>GCC 4.9 or higher. Generally, for Solaris 2.11.1+ (and anything derived from <code>snv_151</code>), the build process roughly matches the <a href="/en-US/docs/Mozilla/Developer_guide/Build_Instructions/Linux_Prerequisites">Linux</a> build:
  <ul>
   <li>WebRTC is still not available</li>
   <li>PulseAudio is now a supported audio backend (in addition to the default OSS backend)</li>
  </ul>
 </li>
</ul>

<p>Set the environment variables as follows:</p>

<pre>export PATH=$PATH:/opt/sunstudio12.1/bin:{gcc PATH}:{autoconf-2.13 PATH}
export CC=[g]cc
export CXX=[CC | g++]</pre>

<p>You can use a typical <code>.mozconfig</code> file. For current HEAD these mozconfigs are recommended:</p>

<div>For Firefox debug build:</div>

<pre>mk_add_options MOZ_OBJDIR=@TOPSRCDIR@/obj-debug
ac_add_options --enable-application=browser
ac_add_options --enable-tests
ac_add_options --disable-jemalloc
ac_add_options --enable-dtrace
ac_add_options --enable-debug
ac_add_options --disable-optimize
ac_add_options --disable-ipc
ac_add_options --disable-libxul
ac_add_options --disable-crashreporter
ac_add_options --disable-verify-mar
</pre>

<div>For Firefox release build:</div>

<pre>mk_add_options MOZ_OBJDIR=@TOPSRCDIR@/obj-release
ac_add_options --enable-application=browser
ac_add_options --enable-tests
ac_add_options --disable-jemalloc
ac_add_options --enable-dtrace
ac_add_options --disable-debug
ac_add_options --enable-optimize
ac_add_options --disable-ipc
ac_add_options --disable-crashreporter
ac_add_options --disable-verify-mar
</pre>

<div>For Thunderbird debug build:</div>

<div>
<pre style='margin: 0px 0px 1.7em; padding: 10px; border-width: 1px; border-style: solid; border-color: rgb(223, 236, 241); overflow: auto; font: 12px "Courier New", "Andale Mono", monospace; color: rgb(37, 34, 29);'>mk_add_options MOZ_OBJDIR=@TOPSRCDIR@/obj-debug
ac_add_options --enable-application=mail
ac_add_options --enable-calendar
ac_add_options --enable-tests
ac_add_options --disable-jemalloc
ac_add_options --enable-dtrace
ac_add_options --enable-debug
ac_add_options --disable-optimize
ac_add_options --disable-ipc
ac_add_options --disable-libxul
ac_add_options --enable-shared
ac_add_options --disable-static
ac_add_options --disable-crashreporter
ac_add_options --disable-verify-mar
</pre>
</div>

<div>For Thunderbird release build:</div>

<div>
<pre style="margin-top: 0px; margin-right: 0px; margin-bottom: 1.7em; margin-left: 0px; padding-top: 10px; padding-right: 10px; padding-bottom: 10px; padding-left: 10px; border-top-width: 1px; border-right-width: 1px; border-bottom-width: 1px; border-left-width: 1px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; font: normal normal normal 12px/normal 'Courier New', 'Andale Mono', monospace; color: rgb(37, 34, 29);">mk_add_options MOZ_OBJDIR=@TOPSRCDIR@/obj-release
ac_add_options --enable-application=mail
ac_add_options --enable-calendar
ac_add_options --enable-tests
ac_add_options --disable-jemalloc
ac_add_options --enable-dtrace
ac_add_options --disable-debug
ac_add_options --enable-optimize
ac_add_options --disable-ipc
ac_add_options --disable-shared
ac_add_options --enable-static
ac_add_options --disable-crashreporter
ac_add_options --disable-verify-mar
</pre>
</div>

<p> Then run <code>gmake -f client.mk</code> to start to build.</p>

<p>Note that the standard Solaris <code>make</code> tool doesn't work. Use <code>gmake</code> instead. (For OpenSolaris, /usr/gnu/bin/make is gmake.)</p>

<h3 id="Patches">Patches</h3>

<p>See <a href="https://github.com/joyent/pkgsrc/tree/trunk/www/firefox/patches">attached</a> files for patches needed to build with Sun Studio 12.1. (The only remaining binary package build for Solaris 2.11.x is built with <a href="https://github.com/joyent/pkgsrc/tree/trunk/www/firefox">this</a> set of patches. If you are building as part of a Solaris distribution, perhaps the <a href="https://github.com/oracle/solaris-userland/tree/master/components/desktop/firefox/patches">upstream Oracle patches</a> may be of interest?)</p>

<p>You will also need to verify that <code>python/mozbuild/mozbuild/mozconfig_loader</code> is a <code>/bin/bash</code> script, not <code>/bin/sh</code>. Make it <code>/bin/bash</code>, if it isnt already.<br>
 Otherwise, you may see errors such as</p>

<pre>mozconfig_loader[57]: .[39]: local: not found [No such file or directory]</pre>

<h3 id="Troubleshooting">Troubleshooting</h3>

<ul>
 <li>You'll get an error if you use <code>make</code> instead of <code>gmake</code>.</li>
</ul>

<pre class="eval">$ make -f client.mk build
make: Fatal error in reader: client.mk, line 126: Unexpected end of line seen

$ gmake -f client.mk build
(this one works!)
</pre>

<ul>
 <li>If the build fails due to missing Makefile.in files check that you unpacked the archive with <code>gtar</code> (<code>/usr/sfw/bin/gtar</code> on Solaris 10) rather than the Solaris <code>tar</code> command.</li>
</ul>

<ul>
 <li>If configure complains about your compiler, ensure you set <code>CC</code> and <code>CXX</code> correctly.</li>
</ul>

<ul>
 <li>If you met a crash when start/close your build of Firefox/Thunderbird with <code>MOZ_gdk_display_close</code> in core stack, you hit <a class="external" href="http://defect.opensolaris.org/bz/show_bug.cgi?id=12024">defect 12024</a> . Set <code>GTK_IM_MODULE=xim</code> to get around.</li>
</ul>

<ul>
 <li>If you want to remote display from SPARC to x86 or x86 to SPARC, please apply the patch in <a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=526977">Bug 526977</a>.</li>
</ul>

<ul>
 <li>If configure tells you the x11 package is missing, save the following text to <code>/usr/lib/pkgconfig/x11.pc</code> (<a class="external" href="http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=6571762">Sun bug 6571762</a>). Alternatively, you can create <code>x11.pc</code> in an arbitrary location and set the <code>PKG_CONFIG_PATH</code> environment variable to the directory containing it.</li>
</ul>

<pre>prefix=/usr/openwin
exec_prefix=${prefix}
libdir=${exec_prefix}/lib
includedir=${prefix}/include

xthreadlib=

Name: X11
Description: X Library
Version: 0.0
Requires: xproto kbproto inputproto
Requires.private: xau xdmcp
Cflags: -I${includedir} -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS -DXTHREADS -DXUSE_MTSAFE_API
Libs: -L${libdir} -R${libdir} -lX11
Libs.private:
</pre>

<ul>
 <li>If you're building on OpenSolaris 2008.05, and configure tells you the xrandr package is missing, save the following text to <code>/usr/lib/pkgconfig/xrandr.pc</code> . Alternatively, you can create xrandr.pc in an arbitrary location and set the <code>PKG_CONFIG_PATH</code> environment variable to the directory containing it.</li>
</ul>

<pre>prefix=/usr/X11
exec_prefix=${prefix}
libdir=${exec_prefix}/lib
includedir=${prefix}/include

Name: Xrandr
Description: X Randr Library
Version: 0.9.4
Requires: xproto renderproto &gt;= 0.9 x11

Cflags: -I${includedir}
Libs: -L${libdir} -R${libdir} -lXrandr
</pre>

<ul>
 <li>If you're building Firefox 2, and mkdepend takes forever on <code>nsIconChannel.cpp</code>, disable automatic dependencies in your mozconfig file to work around {{ Bug(296653) }} (which is fixed on the trunk but not on the branch):</li>
</ul>

<pre>ac_add_options --disable-auto-deps</pre>

<ul>
 <li>If you're building on a recent development version of OpenSolaris (<code>snv_130</code> - <code>snv_132</code>, possibly prior) with the included SunStudio compiler, you may see the a C++ compiler error when running <code>gmake -f client.mk build</code>.  This can be worked around by setting the C++ compiler flags:</li>
</ul>

<pre>export CXXFLAGS="-xannotate=no"
</pre>
